package eu.etaxonomy.taxeditor.prototype2.controller;

import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.prototype2.Activator;

/**
 * Remove a Taxon from the tree without removing it from
 *  the CDM, i.e. when a temporary Taxon has been created for
 *  quickname
 * 
 * @author p.ciardelli
 *
 */
public class ActionRemoveTaxonFromTree extends Action {
	Taxon taxon;
	
	public ActionRemoveTaxonFromTree(Taxon taxon) {
		this.taxon = taxon;
	}
	
	public void run() {
	
		// Remove Taxon from taxon tree list
		Activator.getDefault().getObservableTaxonTreeList().remove(taxon);
		
		taxon = null;
	}
}