package eu.etaxonomy.taxeditor.datasource;

import org.apache.log4j.Logger;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Text;

public class RegisterDatabaseDialog extends TitleAreaDialog {
	private Text txtPort;
	private Text txtHost;
	private Text txtPassword;
	private Text txtLoginName;
	private Table table;
	private Text txtName;
	private static final Logger logger = Logger
			.getLogger(RegisterDatabaseDialog.class);

	/**
	 * Create the dialog
	 * @param parentShell
	 */
	public RegisterDatabaseDialog(Shell parentShell) {
		super(parentShell);
	}

	/**
	 * Create contents of the dialog
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		container.setLayout(gridLayout);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));

		final Label lblName = new Label(container, SWT.NONE);
		lblName.setText("Profile Name:");

		txtName = new Text(container, SWT.BORDER);
		final GridData gd_txtName = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtName.setLayoutData(gd_txtName);

		final Composite rightPanel = new Composite(container, SWT.NONE);
		final GridData gd_rightPanel = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 3);
		rightPanel.setLayoutData(gd_rightPanel);
		rightPanel.setLayout(new GridLayout());

		final Group authenticationGroup = new Group(rightPanel, SWT.NONE);
		authenticationGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		authenticationGroup.setText("Authentication");
		final GridLayout gridLayout_1 = new GridLayout();
		gridLayout_1.numColumns = 2;
		authenticationGroup.setLayout(gridLayout_1);

		final Label lblLoginName = new Label(authenticationGroup, SWT.NONE);
		lblLoginName.setText("Login Name:");

		txtLoginName = new Text(authenticationGroup, SWT.BORDER);
		final GridData gd_txtLoginName = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtLoginName.setLayoutData(gd_txtLoginName);

		final Label lblPassword = new Label(authenticationGroup, SWT.NONE);
		lblPassword.setText("Password:");

		txtPassword = new Text(authenticationGroup, SWT.BORDER);
		final GridData gd_txtPassword = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtPassword.setLayoutData(gd_txtPassword);

		final Label lblSavePassword = new Label(authenticationGroup, SWT.NONE);
		lblSavePassword.setText("Save Password:");

		final Button btnSavePassword = new Button(authenticationGroup, SWT.CHECK);

		final Group locationGroup = new Group(rightPanel, SWT.NONE);
		locationGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		locationGroup.setText("Location");
		final GridLayout gridLayout_2 = new GridLayout();
		gridLayout_2.numColumns = 2;
		locationGroup.setLayout(gridLayout_2);

		final Label lblHost = new Label(locationGroup, SWT.NONE);
		lblHost.setText("Host:");

		txtHost = new Text(locationGroup, SWT.BORDER);
		final GridData gd_txtHost = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtHost.setLayoutData(gd_txtHost);

		final Label portLabel = new Label(locationGroup, SWT.NONE);
		portLabel.setText("Port: <1521>");

		txtPort = new Text(locationGroup, SWT.BORDER);
		final GridData gd_txtPort = new GridData(SWT.FILL, SWT.CENTER, true, false);
		txtPort.setLayoutData(gd_txtPort);

		final Composite composite = new Composite(rightPanel, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
		final GridLayout gridLayout_3 = new GridLayout();
		gridLayout_3.numColumns = 2;
		composite.setLayout(gridLayout_3);

		final Button button = new Button(composite, SWT.NONE);
		button.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false));
		button.setText("button1");

		final Button button_1 = new Button(composite, SWT.NONE);
		button_1.setText("button2");

		final Button btnTestConnection = new Button(rightPanel, SWT.NONE);
		final GridData gd_btnTestConnection = new GridData(SWT.FILL, SWT.CENTER, true, false);
		btnTestConnection.setLayoutData(gd_btnTestConnection);
		btnTestConnection.setText("Test Connection");

		final Label lblDatabase = new Label(container, SWT.NONE);
		lblDatabase.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1));
		lblDatabase.setText("Database:");

		final TableViewer dbTable = new TableViewer(container, SWT.BORDER);
		table = dbTable.getTable();
		table.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		//
		return area;
	}

	/**
	 * Create contents of the button bar
	 * @param parent
	 */
	@Override
	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
				true);
		createButton(parent, IDialogConstants.CANCEL_ID,
				IDialogConstants.CANCEL_LABEL, false);
	}

	/**
	 * Return the initial size of the dialog
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(500, 375);
	}
}
