package eu.etaxonomy.taxeditor;

import org.apache.log4j.Logger;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The activator class controls the plug-in life cycle
 */
public class TaxonomicEditorPlugin extends AbstractUIPlugin {
	private static final Logger logger = Logger
			.getLogger(TaxonomicEditorPlugin.class);

	// The plug-in ID
	public static final String PLUGIN_ID = "eu.etaxonomy.taxeditor.application";

	// The shared instance
	private static TaxonomicEditorPlugin plugin;
	
	/**
	 * The constructor
	 */
	public TaxonomicEditorPlugin() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		logger.debug("Taxonomic Editor started.");
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
		logger.debug("Taxonomic Editor stopped.");
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static TaxonomicEditorPlugin getDefault() {
		return plugin;
	}
}
