// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.bulkeditor.input;


/**
 * @author p.ciardelli
 * @created 25.06.2009
 * @version 1.0
 */
public class AgentEditorInput extends BulkEditorInput {

	public static final String ID = "bulkeditor.input.author";
	
	private static AgentEditorInput instance;

	/**
	 * @param sourceBean
	 */
	public AgentEditorInput() {
		super(new Object());
	}

	/**
	 * @return the iD
	 */
	public static String getID() {
		return ID;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#getName()
	 */
	public String getName() {
		return "Bulk Editor - Authors";
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#getToolTipText()
	 */
	public String getToolTipText() {
		return getName();
	}

	/**
	 * @return
	 */
	public static BulkEditorInput getInstance() {
		if (instance == null) {
			instance = new AgentEditorInput();
		}
		return instance;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.bulkeditor.input.BulkEditorInput#isMergingEnabled()
	 */
	@Override
	public boolean isMergingEnabled() {
		return false;
	}
}