// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.referencingobjects;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
import eu.etaxonomy.taxeditor.model.DescriptionHelper;

/**
 * Requires an <code>IReferencingObjectsService</code> to translate the label
 * elements into displayable text.
 * 
 * @author p.ciardelli
 * @created 09.07.2009
 * @version 1.0
 */
public class ReferencingObjectsLabelProvider extends LabelProvider implements ITableLabelProvider {
	private static final Logger logger = Logger
			.getLogger(ReferencingObjectsLabelProvider.class);

	/**
	 * @param referencingObjectsService
	 */
	public ReferencingObjectsLabelProvider() {
	}

	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		String text = null;
		if (columnIndex == 0) {
			text = (HibernateProxyHelper.deproxy(element)).getClass().getSimpleName();
		}
		if (columnIndex == 1) {
			text = DescriptionHelper.getObjectDescription(element);
		}
		return text == null ? element.toString() : text;
	}
}
