/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.IFormPart;

import eu.etaxonomy.cdm.common.CdmUtils;
import eu.etaxonomy.cdm.model.media.ImageFile;

/**
 * @author p.ciardelli
 *
 */
public class ImageDetailsPage extends AbstractDescriptionDetailsPage implements ModifyListener{
	
	private Text text;
	private Browser browser;

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	public void modifyText(ModifyEvent e) {
		((ImageFile) input).setUri(text.getText());
		fireStateChanged();
	}	
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptionnew.AbstractDescriptionDetailsPage#createContents(org.eclipse.swt.widgets.Composite)
	 */
	public void createContents(Composite parent) {
		super.createContents(parent);
		
		client.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		section.setText("Image Details"); //$NON-NLS-1$

//		// Create composite for moving image up and down in list
//		final Composite moveComposite = new Composite(client, SWT.NONE);
//		moveComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
//		final GridLayout gridLayout1 = new GridLayout();
//		gridLayout1.numColumns = 3;
//		moveComposite.setLayout(gridLayout1);
//		
//		// Create label
//		Label moveLabel = toolkit.createLabel(moveComposite, "Move image in list:", SWT.NONE);
//		moveLabel.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false));		
//		
//		// Create "Up" button
//		final Button upButton = toolkit.createButton(moveComposite, "Up", SWT.PUSH);
//		upButton.setLayoutData(new GridData());
//		upButton.addMouseListener(new MouseAdapter() {
//			public void mouseUp(MouseEvent e) {
//				showImage();
//			}
//		});		
//
//		// Create "Down" button
//		final Button downButton = toolkit.createButton(moveComposite, "Down", SWT.PUSH);
//		downButton.setLayoutData(new GridData());
//		downButton.addMouseListener(new MouseAdapter() {
//			public void mouseUp(MouseEvent e) {
//				showImage();
//			}
//		});		
		
		// Create composite for search text, search term input, and "Search" button
		final Composite urlComposite = new Composite(client, SWT.NONE);
		urlComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		urlComposite.setLayout(gridLayout);
		
		// Create label
		Label urlLabel = toolkit.createLabel(urlComposite, "Image URL:", SWT.NONE);
		urlLabel.setLayoutData(new GridData());
		
		// Create input field for URL
		text = toolkit.createText(urlComposite, "", SWT.BORDER | SWT.SINGLE);
		final GridData gd_text = new GridData(SWT.FILL, SWT.CENTER, true, false);
		text.setLayoutData(gd_text);
		
		// Create "Show" button
		final Button showButton = toolkit.createButton(urlComposite, "Show", SWT.PUSH);
		showButton.setLayoutData(new GridData());
		showButton.addMouseListener(new MouseAdapter() {
			// Populate search results resultsTable after clicking button
			public void mouseUp(MouseEvent e) {
				showImage();
			}
		});	
				 
		browser = new Browser(client, SWT.NONE);
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		// TODO this is a quick fix, couldnt figure out how to get the window to resize for new images
		gd.heightHint = 1000;
		browser.setLayoutData(gd);
		
	}
	
	/**
	 * 
	 */
	private void showImage() {
		String uriString = ((ImageFile) input).getUri();
		String html = "<HTML><HEAD><TITLE>HTML Test</TITLE></HEAD><BODY marginwidth=0 marginheight=0 leftmargin=0 topmargin=0>";
		html += "<img src=\"" + uriString + "\" />";
		html += "</BODY></HTML>";
		browser.setText(html);
	}

	private void moveImage(int direction) {
		
//		IUndoableOperation operation = null;
//		try {
//			// TODO use undo context specific to editor
//			operation = new RemoveImageFromDescriptionElementOperation(event.getCommand().getName(), 
//					EditorUtil.getUndoContext(), taxon, image, element, (IPostOperationEnabled) editor);
//			EditorUtil.executeOperation(operation);
//		} catch (NotDefinedException e) {
//			logger.warn("Command name not set");
//		}
		
		
		
//		ImagesHelper.moveImage((DescriptionElementBase) input, getSelectedImage(), direction);
//		imageViewer.refresh();
//		fireStateChanged();
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptionnew.AbstractDescriptionDetailsPage#selectionChanged(org.eclipse.ui.forms.IFormPart, org.eclipse.jface.viewers.ISelection)
	 */
	@Override
	public void selectionChanged(IFormPart part, ISelection selection) {
		super.selectionChanged(part, selection);
		
		text.removeModifyListener(this);
		text.setText(
				CdmUtils.Nz(((ImageFile) input).getUri()));
		showImage();
		text.addModifyListener(this);
		
		showImage();
	}
}