/**
 * 
 */
package eu.etaxonomy.taxeditor.propertysheet.authors;

import java.util.List;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.cdm.model.agent.Team;

/**
 * @author p.ciardelli
 *
 */
public class TeamAuthorsListDescriptor extends PropertyDescriptor {

	private Team team;

	/**
	 * @param idAuthors
	 * @param authors
	 * @param team
	 */
	public TeamAuthorsListDescriptor(String id, String displayName,
			Team team) {
		super(id, displayName);
		
		this.team = team;
	}
	
    public CellEditor createPropertyEditor(Composite parent) {
        CellEditor editor = new DialogCellEditor(parent) {

			@Override
			protected Object openDialogBox(Control cellEditorWindow) {
				List<Person> authors = TeamAuthorsListDialog.getAuthorsList(cellEditorWindow.getShell(), team);
				if (authors != null) {
					return new TeamAuthorsListPropertySource(team.getTeamMembers());
				}
				return null;
			}        	
        };
        return editor;
    }

}
