// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.datasource.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.database.ICdmDataSource;
import eu.etaxonomy.taxeditor.datasource.CdmDataSourceRepository;

/**
 * @author n.hoffmann
 * @created 15.04.2009
 * @version 1.0
 */
public class ChangeConnectionHandler extends AbstractHandler {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.handler.AbstractDataSourceHandler#specificExecute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) {
		Shell shell = HandlerUtil.getActiveShell(event);
		ISelection menuSelection = HandlerUtil.getActiveMenuSelection(event);
		ICdmDataSource dataSource = (ICdmDataSource) ((StructuredSelection) menuSelection).getFirstElement();
		
		boolean confirmed = MessageDialog.openConfirm(shell, "Confirm Datasource Change", "Do you really want to connect to this datasource?\n\n"
				+ dataSource.getName());
		
		if(confirmed){
			CdmDataSourceRepository.changeDataSource(dataSource);
		}
		
		return null;
	}
}
