// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs.filteredSelection;

import java.util.UUID;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Sep 21, 2009
 * @version 1.0
 */
public class FilteredTaxonSelectionDialog extends
		AbstractFilteredCdmResourceSelectionDialog<TaxonBase> {
	private static final Logger logger = Logger
			.getLogger(FilteredTaxonSelectionDialog.class);
	
	
	/**
	* @param taxon
	* @return
	*/
	public static TaxonBase selectTaxon(Shell shell) {
		FilteredTaxonSelectionDialog dialog = new FilteredTaxonSelectionDialog(shell, 
				"Choose a taxon", false, null);
		return getSelectionFromDialog(dialog);
	}
	
	/**
	* @param shell
	* @param title
	*/
	protected FilteredTaxonSelectionDialog(Shell shell, String title, boolean multi, TaxonBase taxon) {
		super(shell, title, multi, FilteredReferenceSelectionDialog.class.getCanonicalName(), taxon);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#createExtendedContentArea(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected Control createExtendedContentArea(Composite parent) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.AbstractFilteredCdmResourceSelectionDialog#getPersistentObject(java.util.UUID)
	 */
	@Override
	protected TaxonBase getPersistentObject(UUID uuid) {
		return CdmStore.getTaxonService().getTaxonByUuid(uuid);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.AbstractFilteredCdmResourceSelectionDialog#initModel()
	 */
	@Override
	protected void initModel() {
		model = CdmStore.getTaxonService().getUuidAndTitleCache();
	}
}
