// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.taxeditor.store.internal.TaxeditorStorePlugin;
import eu.etaxonomy.taxeditor.user.view.UserManagerView;

/**
 * @author n.hoffmann
 * @created 01.07.2009
 * @version 1.0
 */
public class ShowUserManagerViewHandler  extends AbstractHandler implements IHandler{
	private static final Logger logger = Logger
			.getLogger(ShowUserManagerViewHandler.class);
	
	public Object execute(ExecutionEvent event) throws ExecutionException {
		try {
			TaxeditorStorePlugin.getDefault().getWorkbench()
				.getActiveWorkbenchWindow().getActivePage().showView(UserManagerView.ID, 
					null, IWorkbenchPage.VIEW_VISIBLE);
		} catch (PartInitException e) {
			logger.error("Error opening user management view.", e);
		}
		return null;
	}
}
