// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.io.wizard;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IImportWizard;
import org.eclipse.ui.IWorkbench;

import eu.etaxonomy.cdm.io.reference.endnote.in.EndnoteImportConfigurator;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Sep 18, 2009
 * @version 1.0
 */
public class EndnoteImportWizard extends AbstractImportWizard<EndnoteImportConfigurator> implements IImportWizard {
	private static final Logger logger = Logger
			.getLogger(EndnoteImportWizard.class);

	private EndnoteImportConfigurator configurator;

	private ImportFromFileDataSourceWizardPage dataSourcePage;

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	@Override
	public boolean performFinish() {
		
		String file = dataSourcePage.getFile();
		
		// TcsXmlImport expects a string that can be used to instantiate a URL instance
		// TODO consolidate import and exports regarding what may be passed in as source
		// will construct a url string for now
		
		file = "file://" + file;
		
		configurator.setSource(file);
		
		CdmStore.getImportHandler().doImport(configurator);
		
		return false;
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.io.AbstractImportWizard#addPages()
	 */
	@Override
	public void addPages() {
		super.addPages();
		
		dataSourcePage = ImportFromFileDataSourceWizardPage.XML();
		addPage(dataSourcePage);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		configurator =  CdmStore.getImportHandler().EndnoteImportConfigurator();
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.io.AbstractImportWizard#getConfigurator()
	 */
	@Override
	public EndnoteImportConfigurator getConfigurator() {
		return configurator;
	}
}
